import _Drawer from "antd/lib/drawer";
import _extends from "@babel/runtime/helpers/extends";
import _inheritsLoose from "@babel/runtime/helpers/inheritsLoose";
import * as React from 'react';
import { BaseDialog } from "../../shared/base/BaseDialog";

var ProDrawer = /*#__PURE__*/function (_BaseDialog) {
  _inheritsLoose(ProDrawer, _BaseDialog);

  function ProDrawer() {
    return _BaseDialog.apply(this, arguments) || this;
  }

  var _proto = ProDrawer.prototype;

  _proto.render = function render() {
    var innerProps = this.transformProps();
    return /*#__PURE__*/React.createElement(_Drawer, _extends({}, this.props, innerProps, {
      onClose: innerProps.onCancel
    }));
  };

  return ProDrawer;
}(BaseDialog);

export { ProDrawer as default };