import * as React from 'react';
import { Component } from 'react';
import { ProTable as OriginalProTable, ActionType, ProColumnType } from '@ant-design/pro-components';
import type { ProFormInstance } from '@ant-design/pro-components';
import { FormProps } from 'rc-field-form/lib/Form';
interface IValueEnum {
    text: string;
    value: string;
    status: string;
}
declare type IExtendsColType = ProColumnType & {
    valueEnum?: IValueEnum[];
    renderTag?: boolean;
};
export declare type IProTableProps = React.ComponentProps<typeof OriginalProTable> & {
    columns?: IExtendsColType;
    intl?: string;
    onValuesChange?: FormProps['onValuesChange'];
};
declare class ProTable extends Component<IProTableProps, any> {
    state: {
        selectedRowKeys: any;
        selectedRows: any[];
        collapsed: boolean;
    };
    actionRef: React.RefObject<ActionType>;
    formRef: React.RefObject<ProFormInstance<any>>;
    onSelectRowsChange: (selectedRowKeys: any, selectedRows: any) => void;
    getSelectedRowKeys(): any;
    getSelectedRows(): any[];
    setSelectedRowKeys(selectedRowKeys: any): void;
    componentDidMount(): void;
    render(): JSX.Element;
}
export default ProTable;
